import threading
import time
import sys
import datetime

s = threading.Semaphore(1)

def compare_and_swap(word, testval, newval):
    global atomic
    if (atomic):
        s.acquire()
    oldval = word[0]
    if word[0] == testval:
        # time.sleep(2)
        word[0] = newval
    if (atomic):
        s.release()
    return oldval

def check(i):
    global count
    global errors
    if (count != -1):
        errors += [(count, i)]
    count = i

def check_release():
    global count
    count = -1

def P(i):
    global bolt
    while compare_and_swap(bolt, 0, 1) == 1:
        pass
    # print("%s +%d" %(datetime.datetime.now(), i))
    # sys.stdout.flush()
    time.sleep(1)
    check(i)
    bolt = [0]
    # print("%s -%d" %(datetime.datetime.now(), i))
    # sys.stdout.flush()
    check_release()
    time.sleep(2)

tests = []
tests += [(True, [(0, i) for i in range(20)])]
tests += [(False, [(0, i) for i in range(20)])]

for i in range(len(tests)):
    t = []
    bolt = [0]
    atomic = tests[i][0]
    count = -1
    errors = []
    for j in range(len(tests[i][1])):
        test = tests[i][1][j]
        time.sleep(test[0])
        t += [threading.Thread(target=P, args=[test[1]])]
        t[-1].start()
    for j in range(len(tests[i][1])):
        t[j].join()
    if errors == []:
        print("test %d ok!" %i)
    else:
        print("test %d failed, the following processes violated the mutual exclusion: %s" %(i, str(errors)))
