import threading
import time

s = threading.Semaphore(1)

def P(i):
    global atomic
    if (atomic):
        s.acquire()
    # print("Il processo %d e' nella sezione critica" %(i))
    time.sleep(1)
    check(i)
    if (atomic):
        s.release()
    time.sleep(2)

def check(i):
    global count
    global errors
    if (count != -1):
        errors += [(count, i)]
    count = i

def check_release():
    global count
    count = -1

tests = []
tests += [(True, [(0, i) for i in range(20)])]
tests += [(False, [(0, i) for i in range(20)])]

for i in range(len(tests)):
    t = []
    atomic = tests[i][0]
    count = -1
    errors = []
    for j in range(len(tests[i][1])):
        test = tests[i][1][j]
        time.sleep(test[0])
        t += [threading.Thread(target=P, args=[test[1]])]
        t[-1].start()
    for j in range(len(tests[i][1])):
        t[j].join()
    if errors == []:
        print("test %d ok!" %i)
    else:
        print("test %d failed, the following processes violated the mutual exclusion: %s" %(i, str(errors)))
