import threading
import random
import time
import datetime

lungh_strettoia = 4
num_macchine = 5

z = threading.Semaphore(1)
strettoia = threading.Semaphore(lungh_strettoia)
s = {"sin": threading.Semaphore(1), "dx": threading.Semaphore(1)}
counters = {"sin": 0, "dx": 0}

def macchina(lato, i):
    z.acquire()
    s[lato].acquire()
    counters[lato] += 1
    if counters[lato] == 1:
        s["dx" if lato == "sin" else "sin"].acquire()
    s[lato].release()
    z.release()

    strettoia.acquire()
    passa_strettoia(lato, i)
    strettoia.release()
    
    s[lato].acquire()
    counters[lato] -= 1
    if counters[lato] == 0:
        s["dx" if lato == "sin" else "sin"].release()
    s[lato].release()

def passa_strettoia(lato, i):
    rnd_time = random.uniform(1,10)
    print("la macchina %d sta per passare la strettoia da %s a %s, e ci mettera' %s secondi" %(i, lato, datetime.datetime.now(), rnd_time))
    time.sleep(rnd_time)
    print("la macchina %d ha passato la strettoia da %s a %s!" %(i, lato, datetime.datetime.now()))

random.seed(507129)
for m in range(num_macchine):
    t = threading.Thread(target=macchina, args=("sin" if random.randint(0, 1) == 0 else "dx", m))
    t.start()
print("Finito?")
